diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 0a51d39b8..295654d4c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -1,22 +1,74 @@
 package net.minecraft.client.render.block.model;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.block.model.generic.BlockModelGeneric;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericActivator;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericAxis;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericBasket;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericBed;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericBrazier;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericButton;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericButtonPainted;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericCake;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericChest;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericChestPainted;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericCropsPumpkin;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericDoor;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericDoorPainted;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericFarmland;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericFence;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericFenceGate;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericFenceGatePainted;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericFencePainted;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericFenceThin;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericFlowerStackable;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericFullyRotatable;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericFurnace;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericLayer;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericLever;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericMatcher;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericPebbles;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericPie;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericPiston;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericPistonHead;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericPortal;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericPressurePlate;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericPressurePlatePainted;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericRope;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericRotatable;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericJar;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericLamp;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericLantern;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericLeaves;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericLeavesCacao;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericLeavesCherryFlowering;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericRepeater;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericShifted;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericPlanksPainted;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericSlab;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericSlabPainted;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericSpikes;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericStairs;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericStairsPainted;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericTorch;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericTrapdoor;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericTrapdoorPainted;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericVeryRotatable;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericCropsWheat;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericWool;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.dispatch.Dispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
 import org.useless.dragonfly.data.block.mojang.BlockModelMojangData;
 
-import java.util.Objects;
-
-import static net.minecraft.client.render.block.model.BlockModelStandard.BLOCK_TEXTURES;
-import static net.minecraft.client.render.block.model.BlockModelStandard.RETRO_BLOCK_TEXTURES;
-
 public final class BlockModelDispatcher
     extends Dispatcher<Block<?>, BlockModel<?>> {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private static final Side[] S_TB = {Side.TOP, Side.BOTTOM};
     private static final Side[] S_SIDES = {Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST};
 
@@ -45,9 +97,12 @@ public final class BlockModelDispatcher
         return modelEmpty;
     }
 
-    private static @NotNull BlockModelMojangData loadDataModel(@NotNull final String id) {
+    public static @NotNull BlockModelMojangData loadDataModel(@NotNull final String id) {
         final Minecraft mc = Minecraft.getMinecraft();
-        return Objects.requireNonNull(BlockModelMojangData.Cache.loadModelData(mc.texturePackList, id), "Cannot find model for id '" + id + "'!");
+        BlockModelMojangData model = BlockModelMojangData.Cache.loadModelData(mc.texturePackList, id);
+        if (model != null) return model;
+        LOGGER.error("Could not find model for id '{}'!", id);
+        return BlockModelMojangData.Cache.getMissingModel();
     }
 
     private BlockModelDispatcher() {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
index e6eef4658..c82f91d7c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.block.model.generic.BlockModelGenericLeaves;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -13,7 +14,6 @@ import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
 
 public class BlockModelLeaves<T extends BlockLogic> extends BlockModelStandard<T> {
-    protected static boolean fancyGraphics;
     protected final IconCoordinate fancyLeavesTexture;
     protected final boolean canBeRetro;
 
@@ -26,15 +26,11 @@ public class BlockModelLeaves<T extends BlockLogic> extends BlockModelStandard<T
 
     public BlockModelLeaves(Block<T> block, String leavesTex, boolean canBeRetro) {
         super(block);
-        setAllTextures(BLOCK_TEXTURES, leavesTex);
+        setAllTextures(leavesTex);
         this.fancyLeavesTexture = TextureRegistry.getTexture(leavesTex + "_fancy");
         this.canBeRetro = canBeRetro;
     }
 
-    public static void setGraphicsLevel(boolean graphicsLevel) {
-        fancyGraphics = graphicsLevel;
-    }
-
     @Override
     public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
         boolean invTint = renderBlocks.useInventoryTint;
@@ -54,14 +50,14 @@ public class BlockModelLeaves<T extends BlockLogic> extends BlockModelStandard<T
     @Override
     public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         if (this.canBeRetro && isRetro()) {
-            return fancyGraphics ? this.retroLeavesFancy : this.retroLeaves;
+            return BlockModelGenericLeaves.fancyGraphics ? this.retroLeavesFancy : this.retroLeaves;
         }
-        return fancyGraphics ? this.fancyLeavesTexture : super.getBlockTextureFromSideAndMetadata(side, data);
+        return BlockModelGenericLeaves.fancyGraphics ? this.fancyLeavesTexture : super.getBlockTextureFromSideAndMetadata(side, data);
     }
 
     @Override
     public boolean shouldSideBeRendered(@NotNull WorldSource source, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @NotNull Side side) {
-        if (!fancyGraphics && source.getBlockId(tilePos) == this.block.id()) {
+        if (!BlockModelGenericLeaves.fancyGraphics && source.getBlockId(tilePos) == this.block.id()) {
             return false;
         } else {
             return super.shouldSideBeRendered(source, bounds, tilePos, side);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSignPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSignPainted.java
index a6687f240..8b9164852 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSignPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSignPainted.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.block.model.generic.BlockModelGenericPlanksPainted;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicSignPainted;
@@ -14,6 +15,6 @@ public class BlockModelSignPainted<T extends BlockLogicSignPainted> extends Bloc
 
     @Override
     public @Nullable IconCoordinate getParticleTexture(@NotNull final Side side, final int meta) {
-        return BlockModelPlanksPainted.texCoords[this.block.getLogic().fromMetadata(meta).blockMeta];
+        return BlockModelGenericPlanksPainted.texCoords[this.block.getLogic().fromMetadata(meta).blockMeta];
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
index e78c9b378..191cea573 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
@@ -10,24 +10,22 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelSlab<T extends BlockLogicSlab> extends BlockModelStandard<T> {
-    protected BlockModelStandard<T> parentModel;
+    protected BlockModel<?> parentModel;
 
     public BlockModelSlab(Block<T> block) {
         super(block);
-        this.parentModel = (BlockModelStandard<T>) BlockModelDispatcher.getInstance().getDispatch(this.block.getLogic().modelBlock);
-        this.blockTextures.copy(this.parentModel.blockTextures);
-        this.retroBlockTextures.copy(this.parentModel.retroBlockTextures);
+        this.parentModel = BlockModelDispatcher.getInstance().getDispatch(this.block.getLogic().modelBlock);
         withCustomItemBounds(0, 0, 0, 1, 0.5d, 1);
     }
 
     @Override
     public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
-        return this.parentModel.getBlockTextureFromSideAndMetadata(side, this.block.getLogic().modelBlockMetadata);
+        return this.parentModel.getParticleTexture(side, this.block.getLogic().modelBlockMetadata);
     }
 
     @Override
     public @Nullable IconCoordinate getBlockTexture(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
-        return this.parentModel.getBlockTextureFromSideAndMetadata(side, this.block.getLogic().modelBlockMetadata);
+        return this.parentModel.getParticleTexture(side, this.block.getLogic().modelBlockMetadata);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
index 4ac11a6d5..cbee89718 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
@@ -17,13 +17,11 @@ public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStan
     protected static final DisplayPos STAIRS_GUI = new DisplayPos(0, 0, 0, 30, 135, 0, 0.625f, 0.625f, 0.625f);
     protected static final DisplayPos STAIRS_HEAD = new DisplayPos(0, 0, 0, 0, -90, 0, 1f, 1f, 1f);
     protected static final DisplayPos STAIRS_THIRD_PERSON_LEFT_HAND = new DisplayPos(0, 2.5f / 16f, 0, 75, -135, 0, 0.375f, 0.375f, 0.375f);
-    protected BlockModelStandard<T> parentModel;
+    protected BlockModel<?> parentModel;
 
     public BlockModelStairs(Block<T> block) {
         super(block);
-        this.parentModel = (BlockModelStandard<T>) BlockModelDispatcher.getInstance().getDispatch(this.block.getLogic().modelBlock);
-        this.blockTextures.copy(this.parentModel.blockTextures);
-        this.retroBlockTextures.copy(this.parentModel.retroBlockTextures);
+        this.parentModel = BlockModelDispatcher.getInstance().getDispatch(this.block.getLogic().modelBlock);
 
         setDisplayPos(DisplayPos.GUI, STAIRS_GUI);
         setDisplayPos(DisplayPos.HEAD, STAIRS_HEAD);
@@ -101,12 +99,12 @@ public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStan
 
     @Override
     public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
-        return this.parentModel.getBlockTextureFromSideAndMetadata(side, data);
+        return this.parentModel.getParticleTexture(side, data);
     }
 
     @Override
     public @Nullable IconCoordinate getBlockTexture(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
-        return this.parentModel.getBlockTexture(source, tilePos, side);
+        return this.parentModel.getParticleTexture(side, source.getBlockData(tilePos));
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
index 6bccc7236..adae8ffdd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
@@ -36,11 +36,7 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T> {
     public @Nullable AABBdc itemRenderBounds = null;
     public int renderLayer = 0;
 
-    public static final int BLOCK_TEXTURES = 0;
-    public static final int RETRO_BLOCK_TEXTURES = 2;
-
     protected final TextureLayer blockTextures = new TextureLayer().setAll(BLOCK_TEXTURE_UNASSIGNED);
-    protected final TextureLayer retroBlockTextures = new TextureLayer();
 
     protected @NotNull Map<@NotNull String, @NotNull DisplayPos> displayPosMap = new HashMap<>();
 
@@ -64,8 +60,8 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T> {
     }
 
     @Override
-    public boolean renderWithOverrideTexture(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, IconCoordinate textureIndex) {
-        renderBlocks.overrideBlockTexture = textureIndex;
+    public boolean renderWithOverrideTexture(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, IconCoordinate overrideTexture) {
+        renderBlocks.overrideBlockTexture = overrideTexture;
         boolean result = render(tessellator, worldSource, tilePos);
         renderBlocks.overrideBlockTexture = null;
         return result;
@@ -142,9 +138,6 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T> {
     }
 
     public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
-        if (this.retroBlockTextures.hasTexture && isRetro()) {
-            return this.retroBlockTextures.get(side);
-        }
         return this.blockTextures.get(side);
     }
 
@@ -221,51 +214,23 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T> {
         return this;
     }
 
-    public BlockModelStandard<T> setTex(int layer, @Nullable IconCoordinate coordinate, Side... sides) {
-        switch (layer) {
-            case BLOCK_TEXTURES:
-                this.blockTextures.set(coordinate, sides);
-                break;
-            case RETRO_BLOCK_TEXTURES:
-                this.retroBlockTextures.set(coordinate, sides);
-                break;
-        }
+    public BlockModelStandard<T> setTex(@Nullable IconCoordinate coordinate, Side... sides) {
+        this.blockTextures.set(coordinate, sides);
         return this;
     }
 
-    public BlockModelStandard<T> setTex(int layer, @Nullable String texture, Side... sides) {
-        switch (layer) {
-            case BLOCK_TEXTURES:
-                this.blockTextures.set(texture, sides);
-                break;
-            case RETRO_BLOCK_TEXTURES:
-                this.retroBlockTextures.set(texture, sides);
-                break;
-        }
+    public BlockModelStandard<T> setTex(@Nullable String texture, Side... sides) {
+        this.blockTextures.set(texture, sides);
         return this;
     }
 
-    public BlockModelStandard<T> setAllTextures(int layer, @Nullable IconCoordinate coordinate) {
-        switch (layer) {
-            case BLOCK_TEXTURES:
-                this.blockTextures.setAll(coordinate);
-                break;
-            case RETRO_BLOCK_TEXTURES:
-                this.retroBlockTextures.setAll(coordinate);
-                break;
-        }
+    public BlockModelStandard<T> setAllTextures(@Nullable IconCoordinate coordinate) {
+        this.blockTextures.setAll(coordinate);
         return this;
     }
 
-    public BlockModelStandard<T> setAllTextures(int layer, @Nullable String texture) {
-        switch (layer) {
-            case BLOCK_TEXTURES:
-                this.blockTextures.setAll(texture);
-                break;
-            case RETRO_BLOCK_TEXTURES:
-                this.retroBlockTextures.setAll(texture);
-                break;
-        }
+    public BlockModelStandard<T> setAllTextures(@Nullable String texture) {
+        this.blockTextures.setAll(texture);
         return this;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
index 3f1d2099f..a6102efdf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
@@ -22,7 +22,7 @@ public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStan
 
     public BlockModelWireRedstone(Block<T> block) {
         super(block);
-        setAllTextures(BLOCK_TEXTURES, "minecraft:block/wire_redstone_cross");
+        setAllTextures("minecraft:block/wire_redstone_cross");
     }
 
     @Override
@@ -33,14 +33,6 @@ public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStan
         if (renderBlocks.overrideBlockTexture != null) {
             cross = renderBlocks.overrideBlockTexture;
         }
-        float brightness = 1.0f;
-//        int lmc = block.getLightmapCoord(worldSource, tilePos);
-//        if (Blocks.lightEmission[block.id] > 0) {
-//            lmc = LightmapHelper.setBlocklightValue(lmc, 15);
-//        }
-        int lmc = LightmapHelper.getLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, tilePos), Math.max(worldSource.getSavedLightValue(LightLayer.Block, tilePos), meta & 0xF));
-        tessellator.setLightmapCoord1i(lmc);
-        tessellator.setColorOpaque3f(brightness, brightness, brightness);
 
         Color color = Colors.allRedstoneColors[meta & 0xF];
         float red = color.getRed() / 255.0f;
@@ -49,7 +41,9 @@ public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStan
 
         TilePos queryPos = new TilePos();
 
-        tessellator.setColorOpaque3f(brightness * red, brightness * green, brightness * blue);
+        int lmc = LightmapHelper.getLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, tilePos), Math.max(worldSource.getSavedLightValue(LightLayer.Block, tilePos), meta & 0xF));
+        tessellator.setLightmapCoord1i(lmc);
+        tessellator.setColorOpaque3f(red, green, blue);
         boolean west = BlockLogicWireRedstone.shouldConnectTo(worldSource, tilePos.west(queryPos), Side.WEST) || !worldSource.isBlockNormalCube(tilePos.west(queryPos)) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, tilePos.add(-1, -1, 0, queryPos), Side.NONE, Side.BOTTOM);
         boolean east = BlockLogicWireRedstone.shouldConnectTo(worldSource, tilePos.east(queryPos), Side.EAST) || !worldSource.isBlockNormalCube(tilePos.east(queryPos)) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, tilePos.add(1, -1, 0, queryPos), Side.NONE, Side.BOTTOM);
         boolean north = BlockLogicWireRedstone.shouldConnectTo(worldSource, tilePos.north(queryPos), Side.NORTH) || !worldSource.isBlockNormalCube(tilePos.north(queryPos)) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, tilePos.add(0, -1, -1, queryPos), Side.NONE, Side.BOTTOM);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
new file mode 100644
index 000000000..b5edb73fa
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
@@ -0,0 +1,118 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.block.model.BlockModel;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.DisplayPos;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T> {
+    public final @NotNull StaticBlockModel staticModel;
+    public boolean render3d = true;
+    public boolean forceCullSelf = false;
+
+    public BlockModelGeneric(@NotNull final Block<T> block, @NotNull final StaticBlockModel staticModel) {
+        super(block);
+        this.staticModel = staticModel;
+    }
+
+    public BlockModelGeneric(@NotNull final Block<T> block, @NotNull final BlockModelData staticModel) {
+        super(block);
+        this.staticModel = staticModel.asModel();
+    }
+
+    public @NotNull BlockModelGeneric<T> render3D(boolean flag) {
+        this.render3d = flag;
+        return this;
+    }
+
+    public @NotNull BlockModelGeneric<T> forceCullSelf(boolean flag) {
+        this.forceCullSelf = flag;
+        return this;
+    }
+
+    @Override
+    public final boolean renderNoCulling(final @NotNull TessellatorGeneral tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
+        return renderAttached(tessellator, worldSource, tilePos, false, null);
+    }
+
+    @Override
+    public final boolean render(final @NotNull TessellatorGeneral tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
+        return renderAttached(tessellator, worldSource, tilePos, true, null);
+    }
+
+    @Override
+    public final boolean renderWithOverrideTexture(final @NotNull TessellatorGeneral tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos, final IconCoordinate overrideTexture) {
+        return renderAttached(tessellator, worldSource, tilePos, true, overrideTexture);
+    }
+
+    public boolean renderAttached(final @NotNull TessellatorGeneral tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, final @Nullable IconCoordinate overrideTexture) {
+        return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+    }
+
+    @Override
+    public void renderStandalone(final @NotNull TessellatorGeneral tessellator, final int metadata, final int lightmapCoord) {
+        getModelFromData(metadata).renderStandalone(this, tessellator, 0, 0, 0, metadata, lightmapCoord, BlockColorDispatcher.getInstance().getDispatch(this.block));
+    }
+
+    public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
+        return getModelFromData(source.getBlockData(tilePosc));
+    }
+
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return this.staticModel;
+    }
+
+    @Override
+    public boolean shouldItemRender3d() {
+        return this.render3d;
+    }
+
+    @Override
+    public @NotNull DisplayPos getItemDisplayPos(final @NotNull String id) {
+        return this.staticModel.getItemDisplayPos(id);
+    }
+
+    @Override
+    public int renderLayer() {
+        return this.staticModel.renderLayer();
+    }
+
+    public boolean cullSide(@NotNull WorldSource worldSource, @NotNull TilePosc blockPos, @Nullable Direction direction) {
+        if (direction != null) {
+            TilePos shifted = blockPos.add(direction, new TilePos());
+            if (this.forceCullSelf) {
+                return worldSource.getBlock(shifted) == this.block || worldSource.isBlockOpaqueCube(shifted);
+            } else {
+                return worldSource.isBlockOpaqueCube(shifted);
+            }
+        }
+        return false;
+    }
+
+    @Override
+    public @Nullable IconCoordinate getParticleTexture(final @NotNull Side side, final int meta) {
+        return getModelFromData(meta).getParticle(side);
+    }
+
+    @Override
+    public @Nullable IconCoordinate getOverlayTexture(final int meta) {
+        return getModelFromData(meta).getOverlay();
+    }
+
+    @Override
+    public int particleColorIndex(final @NotNull WorldSource worldSource, final @NotNull TilePosc tilePos, @NotNull final Side side, final int meta) {
+        return getModel(worldSource, tilePos).particleColorIndex(side);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericActivator.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericActivator.java
new file mode 100644
index 000000000..6d99429cd
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericActivator.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicActivator;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericActivator<T extends BlockLogic> extends BlockModelGenericVeryRotatable<T> {
+    public final @NotNull StaticBlockModel active;
+    public BlockModelGenericActivator(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/activator_idle"));
+        this.active = BlockModelDispatcher.loadDataModel("minecraft:block/activator_active").asModel();
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        if ((data & BlockLogicActivator.MASK_POWERED) != 0) {
+            return this.active;
+        } else {
+            return super.getModelFromData(data);
+        }
+    }
+}
